from __future__ import with_statement
print "b162"
os.chdir("/home/rlmill/sage/aly_notebook/worksheets/admin/1/cells/3")
def Initialize(Basis_Matrix):
#Input:
#    Basis_Matrix -- n by n matrix
#Output:
#    basis_star -- n by n matrix
#    mue -- n by n matrix
#    k -- integer
#    k_max -- integer
#    B -- list of length n
#    H -- n by n identity matrix
    #this algorithm initializes all the matrices required for both LLL_toy and Gram_Schmidt
    B = [Integer(0) for i in range(Basis_Matrix.nrows())] #this is the list of dot products of rows
    B[Integer(0)] = (Basis_Matrix.rows()[Integer(0)])*(Basis_Matrix.rows()[Integer(0)]) #initializing the first entry

    basis_star = matrix(QQ,Basis_Matrix.nrows(),Basis_Matrix.ncols()) #b* as in Gram-Schmidt
    basis_star[Integer(0)] = Basis_Matrix[Integer(0)] #initializing the first row

    mue = matrix(QQ,Basis_Matrix.nrows(),Basis_Matrix.ncols()) #creating zeros matrix for later

    k = Integer(1) #initializing the indexing at 1
    k_max = Integer(0) #initializing the counter for the number of iterations of the Gram-Schmidt portion
              #of the algorithm

    H = identity_matrix(Basis_Matrix.nrows()) #initializing H, the transformation matrix

    return(basis_star,mue,k,k_max,B,H)

print "e162"
