from __future__ import with_statement
print "b165"
os.chdir("/home/rlmill/sage/aly_notebook/worksheets/admin/1/cells/15")
r"""
Here are some examples of the LLL_toy algorithm implemented on various matrices given an n by n matrix M of row vectors $b_0,b_1,Ellipsis,b_(n-1)$, LLL_toy returns the LLL reduced matrix.

LLL_toy also has two animations associated with it. The first animation represents the changes in the entries of the matrix mue where the entries mue[i,j] are as given in Gram-Schmidt, where mue[i,j] = b_i*b*_j/|b_j| and b*_i = b_i - sum_(j=0)^(i-1)mue[i,j]*b*_j for (1<= i <=n). Each square of the animation represents the entry of mue in the corresponding position. Black represents 0 and lighter colors indicate larger values.  As the matrix mue is initialized to the n x n zero matrix, the animation begins with all the squares black.  The squares appear in lighter shades of gray as the entries' sizes explode, and finally the matrix returns to its original black state as the first LLL condition, abs(mue[i,j])<=1/2 for 1<=j<i<=n, is achieved.

The second animation associated with LLL_toy illustrates the second LLL condition, the Lovasz condition, where we require |b*_i|>=(3/4-mue[i,i-1]^2)*|b*_(i-1)|.  The red lines following the blue lines represent (3/4-\mue[i,i-1]^2)*|b*_(i-1)| and the blue lines |b*_i|, where the x-coordinate is i.

Brief warning:  You need to run is_LLL_reduced after LLL_toy to check that the returned matrix, Basis_Matrix is in fact LLL reduced.  The algorithm seems to be much less consistent with larger n, currently n>5.
"""

print "e165"
