from __future__ import with_statement
print "b182"
os.chdir("/home/rlmill/sage/aly_notebook/worksheets/admin/1/cells/0")
def RED(k,l,mue,Basis_Matrix,H):
#this algorithm assures the first LLL condition is achieved

#Input:
#    k -- integer < Basis_Matrix.nrows()= n
#    l -- integer < k
#    mue -- n by n matrix
#    Basis_Matrix -- n by n matrix
#    H -- n by n matrix
#Output:
#    mue -- n by n matrix
#    Basis_Matrix -- n by n matrix
#    H -- n by n matrix


    if abs(mue[k,l]) <= RealNumber('0.5'):
        #this checks the first condition
        #if satisfied, exit subroutine
        return(mue,Basis_Matrix,H)
    if abs(mue[k,l]) > RealNumber('0.5'):
        #if the first condition is not satisfied, reduce mue[k,l] by q to satisfy it
        q = integer_floor(mue[k][l]+RealNumber('0.5'))

        #now correct Basis_Matrix, H, and mue to make sure that the Gram-Schmidt
        #definitions are kept
        Basis_Matrix[k] = Basis_Matrix[k]-q*Basis_Matrix[l]
        H[k] = H[k]-q*H[l]

        mue[k,l] = mue[k,l]-q
        for i in range(l):
            mue[k,i] = mue[k,i]-q*mue[l,i]

    return(mue,Basis_Matrix,H)

print "e182"
