from __future__ import with_statement
print "b183"
os.chdir("/home/rlmill/sage/aly_notebook/worksheets/admin/1/cells/2")
def SWAP(k,k_max,mue,B,Basis_Matrix,basis_star,H):
#this is the algorithm that assures the second LLL criteria is reached
#this subroutine is only entered if the Lovasz condition for k has already failed
#it swaps rows k and k-1 of Basis_Matrix and then updates everything in accordance
#to the Gram-Schmidt definitions before we return to step three to try again
#Input:
#    k -- integer < Basis_Matrix.nrows()= n
#    l -- integer < k
#    mue -- n by n matrix
#    B -- list of length n
#    Basis_Matrix -- n by n matrix
#    basis_star -- n by n matrix
#    H -- n by n matrix
#Output:
#    mue -- n by n matrix
#    B -- list of length n
#    basis_star -- n by n matrix
#    Basis_Matrix -- n by n matrix
#    H -- n by n matrix
    Basis_Matrix.swap_rows(k,k-Integer(1))
    H.swap_rows(k,k-Integer(1))
    mue_swap = copy(mue)

    for i in range(k-Integer(1)):
        mue[k,i] = mue_swap[k-Integer(1),i]
        mue[k-Integer(1),i] = mue_swap[k,i]

    mue_entry = mue[k,k-Integer(1)]
    B_swap = B[k] + mue_entry**Integer(2)*B[k-Integer(1)]
    mue[k,k-Integer(1)] = mue_entry*B[k-Integer(1)]/B_swap

    basis_entry = basis_star[k-Integer(1)]
    basis_star = basis_star.rows()
    basis_star[k-Integer(1)] = basis_star[k]+mue_entry*basis_entry
    basis_star[k] = -mue[k,k-Integer(1)]*basis_star[k] + B[k]/B_swap*basis_entry
    basis_star = matrix(basis_star)

    B[k] = B[k-Integer(1)]*B[k]/B_swap
    B[k-Integer(1)] = B_swap

    for i in range(k+Integer(1),k_max+Integer(1)):
        t = mue[i,k]
        mue[i,k] = mue[i,k-Integer(1)] - mue_entry*t
        mue[i,k-Integer(1)] = t + mue[k,k-Integer(1)]*mue[i,k]

    return(mue,B,basis_star,Basis_Matrix,H)

print "e183"
